import { Wrapper } from './wrapper'
import { Environment, Errors, Events, Utils } from './utils'

class Server extends Wrapper {
    constructor() {
        super()
    }

    public resolveEmitDestination(player: any, dataRaw: string) {
        if (!dataRaw) throw new Error(Errors.NO_DATA)

        let state = Utils.prepareExecution(dataRaw)

        switch (state.calledTo) {
            case Environment.SERVER:
                this.emit(player, dataRaw)
                break

            default:
                this.emitClient(player, dataRaw)
                break
        }
    }

    private emitClient(player: any, dataRaw: string) {
        player.call(Events.EVENT_LISTENER, dataRaw)
    }

    private emit(player: any, dataRaw: string) {
        let state = Utils.prepareExecution(dataRaw)

        state = this.verifyEvent_(state)
        if (state.knownError) {
            this.triggerError_(state, state.knownError)
            return
        }

        const { eventName, data } = Utils.prepareExecution(dataRaw)
        this.state_[eventName](...data)
    }
}

const server = new Server()
export { server }
